<?php
/* Box293 Demonstration CONFIG WIZARD */

/* Required include */
include_once(dirname(__FILE__).'/../configwizardhelper.inc.php');

/* Run the initialization function */

/* for all function names, prepend function name with the wizard's name */
/* Example: function box293demo_configwizard_init() */
box293demo_configwizard_init();

function box293demo_configwizard_init(){
	
	/* Name / ID for config wizard */
	$name = 'box293demo';
	
	/* Relevant info for wizard */
	$args = array(
		CONFIGWIZARD_NAME => $name,
		CONFIGWIZARD_TYPE => CONFIGWIZARD_TYPE_MONITORING,
		CONFIGWIZARD_DESCRIPTION => 'This wizard is an example of how to code Conifuguration Wizards.<br />It should be used as a reference tool for customising your own wizards.',
		CONFIGWIZARD_DISPLAYTITLE => 'Box293 Demonstration Wizard',
		CONFIGWIZARD_FUNCTION => 'box293demo_configwizard_func',
		CONFIGWIZARD_PREVIEWIMAGE => 'screen2.png',
		CONFIGWIZARD_VERSION => '2012-08-05',
		CONFIGWIZARD_DATE => '2012-08-05',
		CONFIGWIZARD_AUTHOR => 'Troy Lea aka Box293',
		);
	/* Register wizard with XI */
	register_configwizard($name,$args);
	}

/* This function is automatically called by the XI wizard framework when the wizard is run */
function box293demo_configwizard_func($mode = '',$inargs = null,&$outargs,&$result){

	/* Define the wizard name */
	$wizard_name = 'box293demo';

	/* Initialize return code and output */
	$result = 0;
	$output = '';
	
	/* Initialize output args - pass back the same data we got -> used by XI framework, don't change */
	$outargs[CONFIGWIZARD_PASSBACK_DATA] = $inargs;

	/* The wizard will advanced depending on which mode/stage it's in. */
	/* wizard functions with the following pattern: <show stage html> -> <validate stage> -> <show next stage html> */
	/* CONFIGWIZARD_MODE_GETSTAGE1HTML */
	/* CONFIGWIZARD_MODE_VALIDATESTAGE1DATA */
	/* CONFIGWIZARD_MODE_GETSTAGE2HTML */
	/* CONFIGWIZARD_MODE_VALIDATESTAGE2DATA */
	/* CONFIGWIZARD_MODE_GETSTAGE3OPTS */
	/* CONFIGWIZARD_MODE_GETSTAGE3HTML */
	/* CONFIGWIZARD_MODE_VALIDATESTAGE3DATA */
	/* CONFIGWIZARD_MODE_GETSTAGE4OPTS */
	/* CONFIGWIZARD_MODE_GETFINALSTAGEHTML */
	/* CONFIGWIZARD_MODE_GETOBJECTS */
	
	/* Main Wizard Stage switch */
	switch ($mode) {
		case CONFIGWIZARD_MODE_GETSTAGE1HTML:
			/* This defines $back variable, used for determining if the Back button */
			/* was clicked when the user was on CONFIGWIZARD_MODE_GETSTAGE2HTML */
			$back = htmlentities(grab_array_var($_POST,'backButton',false),ENT_QUOTES); 
			
			/* This defines $nextstep variable, used for determining if the user did not */
			/* provide correct information when the user was on CONFIGWIZARD_MODE_GETSTAGE1HTML */
			$nextstep = htmlentities(grab_array_var($_POST,'nextstep',false),ENT_QUOTES); 
			
			/* The following THREE lines can be enabled for debugging purposes */
			//print_r('<br />post CONFIGWIZARD_MODE_GETSTAGE1HTML<br />'); 
			//print_r($_POST); 
			//print_r('<br /><br />'); 
			
			/* The following THREE lines can be enabled for debugging purposes */
			//print_r('<br />session CONFIGWIZARD_MODE_GETSTAGE1HTML<br />'); 
			//print_r($_SESSION); 
			//print_r('<br /><br />'); 
			
			/* The following THREE lines can be enabled for debugging purposes */
			//print_r('<br />session[box293demo] CONFIGWIZARD_MODE_GETSTAGE1HTML<br />'); 
			//print_r($_SESSION[$wizard_name]); 
			//print_r('<br /><br />'); 
			
			/* Determine if this is the first wizard run */
			if ($nextstep == '') {
				/* Clear the session array to be sure it is blank */
				unset($_SESSION[$wizard_name]); 
				}
			
			/* Check to see if we are coming back from CONFIGWIZARD_MODE_GETSTAGE2HTML */
			if ($back == 'Back') {
				/* User pressed Back button on CONFIGWIZARD_MODE_GETSTAGE2HTML */
				/* The following line can be enabled for debugging purposes */
				//print_r('<br />User pressed Back button on CONFIGWIZARD_MODE_GETSTAGE2HTML<br />'); 
				
				/* Back was clicked when user was on CONFIGWIZARD_MODE_GETSTAGE2HTML so we need to define some variables */
				$address = $_SESSION[$wizard_name]['address'];
				$select1 = $_SESSION[$wizard_name]['select1'];
				}
			else {
				/* Fresh Wizard Run */
				/* OR */
				/* Continuing from CONFIGWIZARD_MODE_VALIDATESTAGE1DATA due to user error */
				
				if (!isset($_POST['address'])) {
					/* Fresh Wizard Run */
					/* The following line can be enabled for debugging purposes */
					//print_r('<br />First Time The Wizard has been run <br />');
					
					/* Define the session array to hold data from different stages */
					$_SESSION[$wizard_name] = array(); 
					
					/* The following variables need to be defined to prevent coding errors */
					$address = '';
					$select1 = '';	
					}
				else {
					/* Continuing from CONFIGWIZARD_MODE_VALIDATESTAGE1DATA due to user error */
					/* The following line can be enabled for debugging purposes */
					//print_r('<br />Continuing from CONFIGWIZARD_MODE_VALIDATESTAGE1DATA due to user error<br />'); 
					
					/* Grab user data already provided from CONFIGWIZARD_MODE_GETSTAGE1HTML */
					$address = grab_array_var($inargs,'address','');
					$select1 = grab_array_var($inargs,'select1','');
					}
				}	
			
			
			/* Now we are creating the HTML for CONFIGWIZARD_MODE_GETSTAGE1HTML */ 
			$output = '
			<!-- This is how you link an external Cascading Style Sheets file -->
			<link href="../includes/configwizards/'.$wizard_name.'/'.$wizard_name.'.inc.css" rel="stylesheet" type="text/css" />
			<!-- This is how you link an external Javascript/jQuery file -->
			<script type="text/javascript" src="../includes/configwizards/'.$wizard_name.'/'.$wizard_name.'.inc.js"></script>

			<p>
			This is the Box293 Demonstration Wizard and you are now on CONFIGWIZARD_MODE_GETSTAGE1HTML
			</p>
			<p>
			<div>
				<input type="button" class="button01" onclick="toggleMe(\'para1\')" value="Overview">
				<!-- NOTE: class="button01" is how I turn a normal button into something that doesn\'t look like a button using the external CSS file -->
				<!-- NOTE: onclick="toggleMe(\'para1\')" is how I expand/collapse the DIV using a function in the external Javascript/jQuery file -->
			</div>
			<div id="para1" style="display:none">
				<br />
				This is the Box293 Demonstration Wizard.
				<br />
				<br />
				I created this for myself as reference material and as a template for new wizards I create. Hence it may not be formatted as aesthetically as my other projects.
				<br />
				<br />
				Additionally this is a coding example of how external CSS and Javascript/jQuery files can be used.
				<br />
				<br />
				One of the key concepts I aim for with a configuration wizard is putting all the help on the first page of the wizard.
				<br />
				This saves you having to go off and find the "manual" for the configuration wizard. It\'s all in hidden DIVs that are expandable/collapsible; so it\'s not like this information "gets in the way" every time you run the wizard.
				<br />
				<br />
				It really helps if you provide all the steps required to make the wizard work in your environment. Things like how to configure SNMP on a Windows server or install the vSphere SDK on the Nagios XI box.
				<br />
				<br />
			</div> 
			
			<div>
				<input type="button" class="button01" onclick="return toggleMe(\'para900\')" value="Discount Offer">
			</div>
			<div id="para900" style="display:none">
				<br />
				Get a <b>10%</b> discount on your Nagios XI Unlimited Nodes license when purchased through <a href="http://www.nagios.com/nagiosxi10?ref=box293" target="_blank"><b>this link</b></a>.
				<br />
				<br />
			</div>
			
			<div>
				<input type="button" class="button01" onclick="return toggleMe(\'para910\')" value="License">
			</div>
			<div id="para910" style="display:none">
				Normally I provide the GNU GENERAL PUBLIC LICENSE in my projects. Due to this being a demonstration wizard I do not want to fill up the wizard with 600+ lines of code. <a href="http://www.gnu.org/licenses/gpl-3.0-standalone.html" target="_blank"><b>Click here</b></a> to read the online version.
				<br />
				<br />
			</div>
			
			<div>
				<input type="button" class="button01" onclick="return toggleMe(\'para920\')" value="Project Hours">
			</div>
			<div id="para920" style="display:none">
				Approximately 20 hours have been spent on this project.
				<br />
				<br />
			</div>
			
			<p>
			On this stage you are required to provide the IP Address or FQDN of the host that you wish to monitor.
			<br />
			The address field IS required and if it is not supplied you will NOT be able to progress to CONFIGWIZARD_MODE_GETSTAGE2HTML.
			<br />
			The select drop down list is NOT required and if it is not supplied you WILL be able to progress to CONFIGWIZARD_MODE_GETSTAGE2HTML.
			<br />
			<br />
			The important thing that you will notice here is that the information you provide in the address and select will be repopulated if you clicked the BACK button when on CONFIGWIZARD_MODE_GETSTAGE2HTML.
			<br />
			Additionally if you did come back from CONFIGWIZARD_MODE_GETSTAGE2HTML and changed the address and/or the select values they will be updated when you go to CONFIGWIZARD_MODE_GETSTAGE2HTML and also if you clicked BACK again on CONFIGWIZARD_MODE_GETSTAGE2HTML.
			<br />
			</p>
			<label for="address">IP Address or FQDN:</label>
			<br />
			<input type="text" name="address" id="address" value="'.$address.'" />
			<br />
			<br />
			<label for="select1">Select an option for select1:</label>
			<br />
			<select name="select1">
				<option value="'.$select1.'">'.$select1.'</option>
				<option value="Option 1">Option 1</option>
				<option value="Option 2">Option 2</option>
				<option value="Option 3">Option 3</option>
				<option value="Option A">Option A</option>
				<option value="Option B">Option B</option>
				<option value="Option C">Option C</option>
			</select>
			<br />
			<br />
			<p>
			Click <b>Next</b> to continue.
			</p>
			';
			/* The quote and semicolon ends HTML for CONFIGWIZARD_MODE_GETSTAGE1HTML */ 
			/* $output will be passed back to XI framework and rendered to browser */
			/* The next line ends CONFIGWIZARD_MODE_GETSTAGE1HTML */
			break;

			
		/* Form validation for CONFIGWIZARD_MODE_GETSTAGE1HTML */
		case CONFIGWIZARD_MODE_VALIDATESTAGE1DATA:		
			/* This defines $back variable, used for determining if the Back button */
			/* was clicked when the user was on CONFIGWIZARD_MODE_GETSTAGE2HTML */
			$back = htmlentities(grab_array_var($_POST,'backButton',false),ENT_QUOTES); 	
			
			/* If the user came back from CONFIGWIZARD_MODE_GETSTAGE3HTML then we don't need to revalidate and check for errors */
			if ($back) break;	
			
			/* Get variables that were passed to us */
				/* NOTE: grab_array_var is an XI wrapper function to fetch values 'if they exist' */
				/* USAGE: grab_array_var($array, $variable, $defaultValue) */
			$address = grab_array_var($inargs,'address','');
			$select1 = grab_array_var($inargs,'select1','');
						
			/* Now lets check for errors before proceeding to CONFIGWIZARD_MODE_GETSTAGE2HTML*/
			/* Set the error count to 0 */
			$errors = 0;
			/* Create the error messages array */
			$errmsg = array();
			/* Check to see if the address field was blank */
			if (have_value($address) == false)
				/* address field was blank, add an error message to the array and increment the $errors count */
				$errmsg[$errors++] = 'No address specified.';
			if (host_exists($address))
				/* address already exists, add an error message to the array and increment the $errors count */
				$errmsg[$errors++] = 'Host name already exists.'; 
			
			/* In this demo we don't care if select1 was selected or not so we don't need to error check on it */
			/* HOWEVER the following code WOULD perform that check */
			//if ($select1 == '')
			//	/* select1 was not selected, add an error message to the array and increment the $errors count */
			//	$errmsg[$errors++] = 'select1 was NOT selected'; 
			
			/* Check to see if the $errors array contains errors */
			if ($errors>0){
				$outargs[CONFIGWIZARD_ERROR_MESSAGES] = $errmsg;
				$result = 1;
				}
			
			/* The next line ends CONFIGWIZARD_MODE_VALIDATESTAGE1DATA */
			break;

			
		case CONFIGWIZARD_MODE_GETSTAGE2HTML:
			/* This defines $back variable, used for determining if the Back button */
			/* was clicked when the user was on CONFIGWIZARD_MODE_GETSTAGE3HTML */
			$back = htmlentities(grab_array_var($_POST,'backButton',false),ENT_QUOTES); 		
			
			/* The following THREE lines can be enabled for debugging purposes */
			//print_r('<br />post CONFIGWIZARD_MODE_GETSTAGE2HTML<br />'); 
			//print_r($_POST); 
			//print_r('<br /><br />'); 

			/* The following THREE lines can be enabled for debugging purposes */
			//print_r('<br />session CONFIGWIZARD_MODE_GETSTAGE2HTML<br />'); 
			//print_r($_SESSION); 
			//print_r('<br /><br />'); 
			
			/* The following THREE lines can be enabled for debugging purposes */
			//print_r('<br />session[box293demo] CONFIGWIZARD_MODE_GETSTAGE2HTML<br />'); 
			//print_r($_SESSION[$wizard_name]); 
			//print_r('<br /><br />'); 
			
			/* Check to see if we are coming back from CONFIGWIZARD_MODE_GETSTAGE3HTML */
			if ($back == 'Back') {
				/* User pressed Back button on CONFIGWIZARD_MODE_GETSTAGE3HTML */
				/* The following line can be enabled for debugging purposes */
				//print_r('<br />User pressed Back button on CONFIGWIZARD_MODE_GETSTAGE3HTML<br />'); 
				
				/* Back was clicked when user was on CONFIGWIZARD_MODE_GETSTAGE3HTML so we need to define some variables */
				$address = $_SESSION[$wizard_name]['address'];
				$hostname = $_SESSION[$wizard_name]['hostname'];
				$select1 = $_SESSION[$wizard_name]['select1'];
				$textarea = $_SESSION[$wizard_name]['textarea'];
				$checkbox1 = $_SESSION[$wizard_name]['checkbox1'];  
				if ($checkbox1 == 'on') 
					$checkbox1_setting = 'checked';
				else $checkbox1_setting = '';
				$radio1 = $_SESSION[$wizard_name]['radio1'];
				}
			else {
				/* Continuing from CONFIGWIZARD_MODE_GETSTAGE1HTML */
				/* OR */
				/* Continuing from CONFIGWIZARD_MODE_VALIDATESTAGE2DATA due to user error */
				
				if (isset($_POST['address'])) {
					/* Continuing from CONFIGWIZARD_MODE_GETSTAGE1HTML */
					/* The following line can be enabled for debugging purposes */
					//print_r('<br />Continuing from CONFIGWIZARD_MODE_VALIDATESTAGE1DATA<br />'); 
					
					/* Grab array variables from CONFIGWIZARD_MODE_GETSTAGE1HTML */
					$address = grab_array_var($inargs,'address','');
					$select1 = grab_array_var($inargs,'select1','');
				
					/* We will save these to the session variable array for later use */
					$_SESSION[$wizard_name]['address'] = $address; 
					$_SESSION[$wizard_name]['select1'] = $select1; 
					
					/* The following function queries DNS using $addess to see if it can determine a FQDN for the object */
					/* Obviously this is more relevant when the user provided an IP Address on CONFIGWIZARD_MODE_GETSTAGE1HTML */
					$hostname = gethostbyaddr($address);
					
					/* The following variables need to be defined to prevent coding errors */
					$textarea = '';
					$checkbox1_setting = '';
					$radio1 = '';
					}
				else {
					/* Continuing from CONFIGWIZARD_MODE_VALIDATESTAGE2DATA due to user error */
					/* The following line can be enabled for debugging purposes */
					//print_r('<br />Continuing from CONFIGWIZARD_MODE_VALIDATESTAGE2DATA due to user error<br />'); 
					
					/* Grab user data already provided from CONFIGWIZARD_MODE_GETSTAGE1HTML */
					$address = $_SESSION[$wizard_name]['address'];
					$select1 = $_SESSION[$wizard_name]['select1'];
					
					/* Grab user data already provided from CONFIGWIZARD_MODE_GETSTAGE2HTML */
					$hostname = grab_array_var($inargs,'hostname','');
					$textarea = grab_array_var($inargs,'textarea','');
					$checkbox1 = grab_array_var($inargs,'checkbox1','');
					if ($checkbox1 == 'on') 
						$checkbox1_setting = 'checked';
					else $checkbox1_setting = '';
					$radio1 = grab_array_var($inargs,'radio1','');
					}
				}
				
			/* Now we are creating the HTML for CONFIGWIZARD_MODE_GETSTAGE2HTML */ 
			$output = '						
			<!-- This is how you link an external Cascading Style Sheets file -->
			<link href="../includes/configwizards/'.$wizard_name.'/'.$wizard_name.'.inc.css" rel="stylesheet" type="text/css" />
			<!-- This is how you link an external Javascript/jQuery file -->
			<script type="text/javascript" src="../includes/configwizards/'.$wizard_name.'/'.$wizard_name.'.inc.js"></script>
			
			<p>
			This is the Box293 Demonstration Wizard and you are now on CONFIGWIZARD_MODE_GETSTAGE2HTML
			</p>
			<p>
			On this stage you are shown the IP Address or FQDN you provided in CONFIGWIZARD_MODE_GETSTAGE1HTML.
			<br />
			You are also asked what you want to call the hostname in Nagios. This field may already be populated as the wizard queried DNS to determine this (more relevant when an IP Address was supplied).
			<br />
			The hostname field IS required and if it is not supplied you will NOT be able to progress to CONFIGWIZARD_MODE_GETSTAGE3HTML.
			<br />
			<br />
			Additionally if you did come back from CONFIGWIZARD_MODE_GETSTAGE3HTML and changed the hostname or any other field values / checkboxes / droplists they will be updated when you go to CONFIGWIZARD_MODE_GETSTAGE3HTML and also if you clicked BACK again on CONFIGWIZARD_MODE_GETSTAGE3HTML.
			<br />
			</p>
			<br />
			<label for="address">IP Address or FQDN:</label>
			<br />
			<input type="text" size="40" name="address" id="address" value="'.$address.'" class="textfield" disabled/>
			<br />
			<label for="hostname">Host Name:</label>
			<br />
			<input type="text" size="40" name="hostname" id="hostname" value="'.$hostname.'" class="textfield" />
			<br />
			<br />
			Also, if you selected an option from select1 on CONFIGWIZARD_MODE_GETSTAGE1HTML then it would appear here -><b>'.$select1.'</b><-
			<br />
			<br />
			
			<p>
			<label for="textarea">textarea for your enjoyment purposes:</label>
			<br />
			<textarea cols="60" rows="5" wrap="off" name="textarea" id="textarea">'.$textarea.'</textarea>
			</p>
			
			<br />
			
			<p>
			The next section is an example of an option with a sub-option. We have a checkbox that the user can tick. If it gets ticked then the user will also need to specify some information, in this case a radio button needs to be selected.
			<br />
			What is being demonstrated in the back end code is IF the checkbox is ticked then the radio button MUST be selected. If this is not done then the user will NOT be able to progress onto CONFIGWIZARD_MODE_GETSTAGE3HTML.
			<br />
			All of this logic is handled in the error checking phase CONFIGWIZARD_MODE_VALIDATESTAGE2DATA, also there must be some logic at the begining of CONFIGWIZARD_MODE_GETSTAGE2HTML for when the user is coming back from CONFIGWIZARD_MODE_GETSTAGE3HTML so the previous selection for the radio button is repopulated appropriately.
			<br />
			<br />
			<label for="checkbox1">checkbox1:</label>
			<br />
			<input type="checkbox" class="checkbox" name="checkbox1" '.$checkbox1_setting.'>
			<br />
			<br />
			<label for="radio1">radio1:</label>
			<br />
			<input type="radio" name="radio1" value="Option X" '; if ($radio1 == 'Option X') $output .= 'checked="checked"'; $output.='/>Option X
			<br />
			<input type="radio" name="radio1" value="Option Y" '; if ($radio1 == 'Option Y') $output .= 'checked="checked"'; $output.='/>Option Y
			<br />
			<input type="radio" name="radio1" value="Option Z" '; if ($radio1 == 'Option Z') $output .= 'checked="checked"'; $output.='/>Option Z
			<br />
			</p>
			<br />
			<p>
			This last section is demonstrating how you could provide multiple options for a disk usage check.
			<br />
			Specifically in this example, when a user selects these options, service object(s) will be created in the CONFIGWIZARD_MODE_GETOBJECTS stage. You will need to have a look at the code in the CONFIGWIZARD_MODE_GETOBJECTS stage to see exactly what I am talking about.
			<br />
			For simplicity reasons the following drop down lists only have one option already selected and there is no error checking. I have done this so I don\'t need to add extra code. A great example of this can be found in the offical "Windows Server" monitoring wizard that comes with Nagios XI.
			<br />
			<br />
			
			<b>Disk Usage</b>
			<br />
			Monitor disk usage on the server<br>
			<table>
			<tr>
				<td>
					<input type="checkbox" class="checkbox" name="checkbox_disk[0]"
				</td>
				<td>
					<label>Drive:</label>
					<select name="select_disk[0]">
						<option value="C">C:</option>
					</select>
				</td>
			</tr>
			<tr>
				<td>
					<input type="checkbox" class="checkbox" name="checkbox_disk[1]"
				</td>
				<td>
					<label>Drive:</label>
					<select name="select_disk[1]">
						<option value="D">D:</option>
					</select>
				</td>
			</tr>
			<tr>
				<td>
					<input type="checkbox" class="checkbox" name="checkbox_disk[2]"
				</td>
				<td>
					<label>Drive:</label>
					<select name="select_disk[2]">
						<option value="E">E:</option>
					</select>
				</td>
			</tr>
			</table>
			</p>

			<br />
			
			<p>
			Click <b>Next</b> to continue.
			</p>
			';
			/* The quote and semicolon ends HTML for CONFIGWIZARD_MODE_GETSTAGE2HTML */ 
			/* $output will be passed back to XI framework and rendered to browser */
			/* The next line ends CONFIGWIZARD_MODE_GETSTAGE2HTML */
			break;

			
		/* Form validation for CONFIGWIZARD_MODE_GETSTAGE2HTML */ 
		case CONFIGWIZARD_MODE_VALIDATESTAGE2DATA:
			/* This defines $back variable, used for determining if the Back button */
			/* was clicked when the user was on CONFIGWIZARD_MODE_GETSTAGE4HTML */
			$back = htmlentities(grab_array_var($_POST,'backButton',false),ENT_QUOTES); 	
			
			/* If the user came back from CONFIGWIZARD_MODE_GETSTAGE3HTML then we don't need to revalidate and check for errors */
			if ($back) break;	
			
			/* Get variables that were passed to us */
			$hostname = grab_array_var($inargs,'hostname','');
			$textarea = grab_array_var($inargs,'textarea','');
			$checkbox1 = grab_array_var($inargs,'checkbox1','');
			$radio1 = grab_array_var($inargs,'radio1','');
			
			// check for errors
			$errors = 0;
			$errmsg = array();
			
			/* Check to see if a valid hostname was provided */
			if (is_valid_host_name($hostname) == false)
				$errmsg[$errors++] = 'Invalid host name.';
				
			/* Check to see if checkbox1 was ticked */
			if ($checkbox1 == 'on') {
				/* Check to see if a radio1 option was chosen */
				if ($radio1 == '') {
					/* radio1 was blank, add an error message to the array and increment the $errors count */
					$errmsg[$errors++] = 'You must select an option for radio1.';
					}
				}
			
			/* Check to see if the $errors array contains errors */
			if ($errors>0){
				$outargs[CONFIGWIZARD_ERROR_MESSAGES] = $errmsg;
				$result = 1;
				}
			
			/* The next line ends CONFIGWIZARD_MODE_VALIDATESTAGE2DATA */
			break;

		
		case CONFIGWIZARD_MODE_GETSTAGE3HTML:
			/* This defines $back variable, used for determining if the Back button */
			/* was clicked when the user was on CONFIGWIZARD_MODE_GETSTAGE4HTML */
			$back = htmlentities(grab_array_var($_POST,'backButton',false),ENT_QUOTES); 		
			
			/* The following THREE lines can be enabled for debugging purposes */
			//print_r('<br />post CONFIGWIZARD_MODE_GETSTAGE3HTML<br />'); 
			//print_r($_POST); 
			//print_r('<br /><br />'); 
			
			/* The following THREE lines can be enabled for debugging purposes */
			//print_r('<br />session CONFIGWIZARD_MODE_GETSTAGE3HTML<br />'); 
			//print_r($_SESSION[$wizard_name]); 
			//print_r('<br /><br />'); 
			
			/* Check to see if we are coming back from CONFIGWIZARD_MODE_GETSTAGE4HTML OR continuing from CONFIGWIZARD_MODE_GETSTAGE2HTML */
			if (!$back) {
				/* Continuing from CONFIGWIZARD_MODE_GETSTAGE2HTML */
				/* The following line can be enabled for debugging purposes */
				//print_r('Continuing from CONFIGWIZARD_MODE_GETSTAGE2HTML <br />'); 
				
				/* grab array variables from CONFIGWIZARD_MODE_GETSTAGE2HTML */
				$hostname = grab_array_var($inargs,'hostname','');
				$textarea = grab_array_var($inargs,'textarea','');
				$checkbox1 = grab_array_var($inargs,'checkbox1','');
				$radio1 = grab_array_var($inargs,'radio1','');
				$checkbox_disk = grab_array_var($inargs,'checkbox_disk',array());
				$select_disk = grab_array_var($inargs,'select_disk',array());
				
				/* We will save these to the session variable array for later use */
				$_SESSION[$wizard_name]['hostname'] = $hostname;
				$_SESSION[$wizard_name]['textarea'] = $textarea;
				$_SESSION[$wizard_name]['checkbox1'] = $checkbox1;
				$_SESSION[$wizard_name]['radio1'] = $radio1;
				$_SESSION[$wizard_name]['checkbox_disk'] = $checkbox_disk;
				$_SESSION[$wizard_name]['select_disk'] = $select_disk;
				}
			
			/* The following THREE lines can be enabled for debugging purposes */
			//print_r('<br />_SESSION[box293demo]<br />'); 
			//print_r($_SESSION[$wizard_name]); 
			//print_r('<br />'); 
			
			/* Now we are creating the HTML for CONFIGWIZARD_MODE_GETSTAGE3HTML */ 
			$output = '						
			<!-- This is how you link an external Cascading Style Sheets file -->
			<link href="../includes/configwizards/'.$wizard_name.'/'.$wizard_name.'.inc.css" rel="stylesheet" type="text/css" />
			<!-- This is how you link an external Javascript/jQuery file -->
			<script type="text/javascript" src="../includes/configwizards/'.$wizard_name.'/'.$wizard_name.'.inc.js"></script>

			<p>
			This is the Box293 Demonstration Wizard and you are now on CONFIGWIZARD_MODE_GETSTAGE3HTML
			<br />
			<br />
			<b>NOTE:</b> This message will appear on the "Monitoring Settings" step, the "Notification Settings" step,
			<br />
			"Host Groups/Service Groups/Parent Host" step and the "Final" step.
			<br />
			<br />
			The "Monitoring Settings" can be hidden and overwritten using the stage CONFIGWIZARD_MODE_GETSTAGE3OPTS, refer to the php code in this wizard as it explains it all.
			<br />
			<br />
			The "Notification Settings" can be hidden and overwritten using the stage CONFIGWIZARD_MODE_GETSTAGE4OPTS, refer to the php code in this wizard as it explains it all.
			<br />
			<br />
			The "Host Groups/Service Groups/Parent Host" options CANNOT be hidden or overwritten at this point in time <i>(when this Demonstration wizard was last modified, the current Nagios XI release version was 2011R3.2)</i>.
			<br />
			<br />
			The "Final" step CANNOT be hidden.
			<br />
			<br />
			</p>
			';
			/* The quote and semicolon ends HTML for CONFIGWIZARD_MODE_GETSTAGE3HTML */ 
			/* $output will be passed back to XI framework and rendered to browser */
			/* The next line ends CONFIGWIZARD_MODE_GETSTAGE3HTML */
			break;
			
			
		case CONFIGWIZARD_MODE_VALIDATESTAGE3DATA:
			/* No validation necessary for this stage */
			/* The next line ends CONFIGWIZARD_MODE_VALIDATESTAGE3DATA */
			break;
		
	/* This is the CONFIGWIZARD_MODE_GETSTAGE3OPTS stage */
	/* I have intentionally disabled the whole stage but have left the code here for documentation purposes */
	//	case CONFIGWIZARD_MODE_GETSTAGE3OPTS:
	//		/* Use this to hard code the Monitoring Settings options */
	//		/* The below options are currently the only supported options to hard code */
	//		$outargs[CONFIGWIZARD_OVERRIDE_OPTIONS] = array(
	//			'max_check_attempts' 	=> 15,
	//			'check_interval'        => 15,
	//			'retry_interval'        => 15,
	//			);
	//			
	//		/* Use this to hide the Monitoring Settings options */
	//		$result = CONFIGWIZARD_HIDE_OPTIONS;
	//		
	//		/* Now we are creating the HTML for CONFIGWIZARD_MODE_GETSTAGE3OPTS that will appear on CONFIGWIZARD_MODE_GETSTAGE3HTML */ 
	//		$output = '
	//		<p>
	//		<strong>Note:</strong> Manually overriding wizard options for the Monitoring Settings.
	//		</p>
	//		';
	//		/* The quote and semicolon ends HTML for CONFIGWIZARD_MODE_GETSTAGE3OPTS */ 
	//		/* $output will be passed back to XI framework and rendered to browser */
	//		/* The next line ends CONFIGWIZARD_MODE_GETSTAGE3OPTS */
	//		break;
		
		
	/* This is the CONFIGWIZARD_MODE_GETSTAGE4OPTS stage */
	/* I have intentionally disabled the whole stage but have left the code here for documentation purposes */
	//	case CONFIGWIZARD_MODE_GETSTAGE4OPTS:
	//		/* Use this to hard code the Notification Settings options */
	//		/* The below options are currently the only supported options to hard code */
	//		$outargs[CONFIGWIZARD_OVERRIDE_OPTIONS] = array(
	//		   'notification_delay'		=> 15,
	//		   'notification_interval'	=> 15,						
	//			);
	//		
	//		/* Use this to hide the different Notification Settings options */
	//		/* The below options are currently the only supported options to hide */
	//		/* NOTE: If the TARGETS option is hidden, the user running the wizard will be set as the contact TARGET */
	//		$outargs[CONFIGWIZARD_HIDDEN_OPTIONS] = array(
	//			CONFIGWIZARD_HIDE_NOTIFICATION_OPTIONS,
	//			CONFIGWIZARD_HIDE_NOTIFICATION_DELAY,
	//			CONFIGWIZARD_HIDE_NOTIFICATION_INTERVAL,
	//			CONFIGWIZARD_HIDE_NOTIFICATION_TARGETS, 
	//			);
	//		$result = CONFIGWIZARD_HIDE_OPTIONS;
	//		
	//		/* Now we are creating the HTML for CONFIGWIZARD_MODE_GETSTAGE4OPTS that will appear on CONFIGWIZARD_MODE_GETSTAGE3HTML */ 
	//		$output = '
	//		<p>
	//		<strong>Note: </strong>Manually overriding wizard options for Notification Settings.
	//		</p>
	//		';
	//		/* The quote and semicolon ends HTML for CONFIGWIZARD_MODE_GETSTAGE4OPTS */ 
	//		/* $output will be passed back to XI framework and rendered to browser */
	//		/* The next line ends CONFIGWIZARD_MODE_GETSTAGE4OPTS */
	//		break;			
		
	
		case CONFIGWIZARD_MODE_GETFINALSTAGEHTML:
			/* Now we are creating the HTML for CONFIGWIZARD_MODE_GETFINALSTAGEHTML */ 
			$output = '
			<p>
			This is the Final Stage html, which can be used to confirm or review settings.
			<br />
			<br />
			For example:
			<br />
			The address of the host we are going to monitor is <b>'.$_SESSION[$wizard_name]['address'].'</b>
			<br />
			The hostname of the host we are going to monitor is <b>'.$_SESSION[$wizard_name]['hostname'].'</b>
			<br />
			</p>
			';
			/* The quote and semicolon ends HTML for CONFIGWIZARD_MODE_GETFINALSTAGEHTML */ 
			/* $output will be passed back to XI framework and rendered to browser */
			/* The next line ends CONFIGWIZARD_MODE_GETFINALSTAGEHTML */
			break;
		
		
		/* This stage commits the wizard data into objects definitions to be imported */
		case CONFIGWIZARD_MODE_GETOBJECTS:
			/* Get the session data to turn into object configs */
			/* NOTE: I am not bothering with select1, textarea, checkbox1, radio1 */
			/* as they are not used in the following example */
			$address = $_SESSION[$wizard_name]['address'];
			$hostname = $_SESSION[$wizard_name]['hostname'];
			$checkbox_disk = $_SESSION[$wizard_name]['checkbox_disk'];
			$select_disk = $_SESSION[$wizard_name]['select_disk'];
			
			/* Initialize objects array, this will contain the objects that we will add */
			$objs = array();
			
			/* Check to see if the host already exists, if it does then we won't add it */
			if (!host_exists($hostname)) {
				$objs[] = array(
					'type' 			=> OBJECTTYPE_HOST, 		/* This defines the object is a host */
					'use' 			=> 'xiwizard_generic_host',	/* This is how you use a host template */
					'host_name'		=> $hostname,				/* The hostname */
					'address' 		=> $address,				/* The address of the host */
					'_xiwizard' 	=> $wizard_name,			/* This adds a free variable to the host object */
					);
				}
			
			/* Now we will create the disk usage services for this wizard */
			/* I know there are three disk usage options available so let's reiterate through them */
			for ($x = 0; $x < count($select_disk); $x++) {
				/* Check to see if this array object exists */
				if (isset($checkbox_disk[$x])) {
					/* Check to see if this disk was selected */
					if ($checkbox_disk[$x] == 'on') {
						$objs[] = array(
							'type' 					=> OBJECTTYPE_SERVICE,							/* This defines the object is a service */
							'host_name' 			=> $hostname,									/* The hostname of the host this service belongs to*/
							'service_description' 	=> 'Drive '.$select_disk[$x].': Disk Usage',	/* A service description */
							'check_command' 		=> 'check_xi_service_nsclient!!USEDDISKSPACE!-l '.$select_disk[$x].'!',	/* The check command that will be executed */
							'_xiwizard' 			=> $wizard_name,								/* This adds a free variable to the service object */
							);					
						}
					}
				}
			
			/* The following three lines can be enabled for debugging purposes */
			//print_r('<br />Objects Array:<br />');
			//print_r($objs);
			//print_r('<br />');
			
			/* Return the object definitions to the wizard */
			$outargs[CONFIGWIZARD_NAGIOS_OBJECTS] = $objs;
			
			/* clear the session variables for this wizard run */
			unset ($_SESSION[$wizard_name]); 
			
			/* The next line ends CONFIGWIZARD_MODE_GETOBJECTS */
			break;
			
		default:
			break;			
		}
		
	return $output;
	}
?>